import Test.QuickCheck

quicksort :: Ord a => [a] -> [a]
quicksort []     = []
quicksort (p:xs) = (quicksort lesser) ++ [p] ++ (quicksort greater)
    where
        lesser  = filter (< p) xs
        greater = filter (>= p) xs


prop_idempotent xs = quicksort (quicksort xs) == quicksort xs

-- quickCheck (prop_idempotent::[Integer]->Bool)

prop_minim [] = True
prop_minim xs = head (quicksort xs) == minimum xs

-- quickCheck (prop_minim::[Integer]->Bool)

prop_ordenat xs = ordenat (quicksort xs) 

-- quickCheck (prop_ordenat::[Integer]->Bool)
-- verboseCheck (prop_ordenat::[Integer]->Bool)

ordenat [] = True
ordenat [_] = True
ordenat (x:y:xs) = x <= y && ordenat (y:xs)

